import * as i0 from '@angular/core';
import { Injectable, Component, Input, NgModule } from '@angular/core';
import * as d3 from 'd3';

class ResponsivePieChartService {
    constructor() { }
}
ResponsivePieChartService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: ResponsivePieChartService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
ResponsivePieChartService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: ResponsivePieChartService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: ResponsivePieChartService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class ResponsivePieChartComponent {
    constructor(eltRef) {
        this.eltRef = eltRef;
        this.donutHole = 0;
        this.width = 100;
        this.height = 100;
        this.data = [
            {
                name: 'IT',
                value: 4,
                color: 'red'
            },
            {
                name: 'Sales',
                value: 5,
                color: 'blue'
            }
        ];
        this.pieData = [];
        this.radius = 0;
        this.offset = 5;
        this.strokeWidth = 1;
        this.svgWidth = 0;
        this.svgHeight = 0;
    }
    ngOnInit() {
        this.convertData(this.data);
    }
    ngAfterViewInit() {
        this.radius = Math.min(this.width, this.height) / 2;
        this.svgWidth = this.width + this.offset * 2 + this.strokeWidth * 2;
        this.svgHeight = this.height + this.offset * 2 + this.strokeWidth * 2;
        this.buildPie();
    }
    convertData(dataList) {
        let sum = 0;
        dataList.forEach((e) => {
            sum += e.value;
        });
        dataList.forEach(e => {
            let newData = { name: e.name, value: e.value / sum, color: e.color };
            this.pieData.push(newData);
        });
    }
    buildPie() {
        const eltRef = this.eltRef;
        let arc = d3.arc().innerRadius(this.donutHole).outerRadius(this.radius);
        let arcOver = d3.arc().innerRadius(this.donutHole).outerRadius(this.radius + this.offset);
        let svg = d3.select(this.eltRef.nativeElement)
            .select('#pieChart')
            .attr('viewBox', (0 - this.radius - this.offset - this.strokeWidth) + " " + (0 - this.radius - this.offset - this.strokeWidth) + " " + 2 * (this.radius + this.offset + 2 * this.strokeWidth) + " " + 2 * (this.radius + this.offset + 2 * this.strokeWidth));
        let g = svg.append('g');
        // .attr('transform', 'translate(' + this.svgWidth / 2 + ',' + this.svgHeight / 2 + ')')
        // // Generate the pie
        let pie = d3.pie().value((d) => d.value);
        // Generate groups
        let arcs = g.selectAll("arc")
            .data(pie(this.pieData))
            .enter()
            .append("g")
            .attr("class", "arc");
        //Draw arc paths
        arcs.append('path')
            .attr('d', arc)
            .attr("fill", function (d) {
            return d.data.color;
        })
            .attr("stroke", "white")
            .style("stroke-width", this.strokeWidth + "px")
            .on("click", function (event, d) {
            d3.select(this)
                .transition()
                .duration(100)
                .attr("stroke", "grey");
            d3.select(eltRef.nativeElement).select('#tooltip')
                .transition().duration(0)
                .style('left', event.offsetX + 'px')
                .style('top', event.offsetY + 'px')
                .style('opacity', 1)
                .text(d.data.name + ": " + (d.data.value * 100).toFixed(2) + '%');
        })
            .on("mouseover", function (event, d) {
            d3.select(this)
                .transition()
                .duration(100)
                .attr("d", arcOver);
            d3.select(eltRef.nativeElement).select('div#tooltip')
                .transition().duration(0)
                .style('left', event.offsetX + 'px')
                .style('top', event.offsetY + 10 + 'px')
                .style('opacity', 1)
                .text(d.data.name + ": " + (d.data.value * 100).toFixed(2) + '%');
            // d3.select(eltRef.nativeElement).select('#indicator')
            //   .style('opacity', 1)
            //   .text(d.data.name + ": " + (d.data.value*100).toFixed(2)+'%');
        })
            .on("mouseout", function (event, d) {
            d3.select(this)
                .transition()
                .duration(100)
                .attr("d", arc);
            d3.select(eltRef.nativeElement).select('div#tooltip')
                .style('opacity', 0);
            // d3.select(eltRef.nativeElement).select('#indicator')
            // .style('opacity', 0)
            // ;
        });
    }
}
ResponsivePieChartComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: ResponsivePieChartComponent, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component });
ResponsivePieChartComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.12", type: ResponsivePieChartComponent, selector: "lib-responsive-pie-chart", inputs: { donutHole: "donutHole", width: "width", height: "height", data: "data" }, ngImport: i0, template: "<!-- <div class=\"pieGraph\" style=\"position:absolute; top:0; left: 0; height: 100%;width: 100%;\"> -->\n    <div style=\" height: 100%;width: 100%; display:flex; align-items: center; cursor: pointer; position: relative;\">\n        <div id=\"tooltip\" style=\"position:absolute; left: 0;top:0;opacity:0; background-color: white; border-radius: 3px;padding: 3px;\n         box-shadow: rgba(0, 0, 0, 0.3) 0px 19px 38px, rgba(0, 0, 0, 0.22) 0px 15px 12px;\" > \n        </div>\n        <svg id=\"pieChart\" [attr.width]=\"svgWidth\" [attr.height]=\"svgHeight\" ></svg>\n    </div>\n<!-- </div> -->\n    <!-- <div id=\"pieChart\" [attr.width]=\"svgWidth\" [attr.height]=\"svgHeight\" ></div>\n\n    <div id=\"tooltip\" style=\"position:absolute; left: 0;top:0;opacity:0; background-color: white; border-radius: 3px;padding: 3px;\n    box-shadow: rgba(0, 0, 0, 0.3) 0px 19px 38px, rgba(0, 0, 0, 0.22) 0px 15px 12px;\" > \n    </div>\n\n    <div id=\"indicator\" style=\"position:absolute; left: 0;bottom:0;opacity:0; font-size: 13px; margin-left: 5px;\" > </div> -->\n\n\n", styles: [":host{display:flex;justify-content:center;align-items:center}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: ResponsivePieChartComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-responsive-pie-chart', template: "<!-- <div class=\"pieGraph\" style=\"position:absolute; top:0; left: 0; height: 100%;width: 100%;\"> -->\n    <div style=\" height: 100%;width: 100%; display:flex; align-items: center; cursor: pointer; position: relative;\">\n        <div id=\"tooltip\" style=\"position:absolute; left: 0;top:0;opacity:0; background-color: white; border-radius: 3px;padding: 3px;\n         box-shadow: rgba(0, 0, 0, 0.3) 0px 19px 38px, rgba(0, 0, 0, 0.22) 0px 15px 12px;\" > \n        </div>\n        <svg id=\"pieChart\" [attr.width]=\"svgWidth\" [attr.height]=\"svgHeight\" ></svg>\n    </div>\n<!-- </div> -->\n    <!-- <div id=\"pieChart\" [attr.width]=\"svgWidth\" [attr.height]=\"svgHeight\" ></div>\n\n    <div id=\"tooltip\" style=\"position:absolute; left: 0;top:0;opacity:0; background-color: white; border-radius: 3px;padding: 3px;\n    box-shadow: rgba(0, 0, 0, 0.3) 0px 19px 38px, rgba(0, 0, 0, 0.22) 0px 15px 12px;\" > \n    </div>\n\n    <div id=\"indicator\" style=\"position:absolute; left: 0;bottom:0;opacity:0; font-size: 13px; margin-left: 5px;\" > </div> -->\n\n\n", styles: [":host{display:flex;justify-content:center;align-items:center}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { donutHole: [{
                type: Input
            }], width: [{
                type: Input
            }], height: [{
                type: Input
            }], data: [{
                type: Input
            }] } });

class ResponsivePieChartModule {
}
ResponsivePieChartModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: ResponsivePieChartModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
ResponsivePieChartModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.12", ngImport: i0, type: ResponsivePieChartModule, declarations: [ResponsivePieChartComponent], exports: [ResponsivePieChartComponent] });
ResponsivePieChartModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: ResponsivePieChartModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: ResponsivePieChartModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        ResponsivePieChartComponent
                    ],
                    imports: [],
                    exports: [
                        ResponsivePieChartComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of responsive-pie-chart
 */

/**
 * Generated bundle index. Do not edit.
 */

export { ResponsivePieChartComponent, ResponsivePieChartModule, ResponsivePieChartService };
//# sourceMappingURL=responsive-pie-chart.mjs.map
